"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Created by theophy on 02/08/2017.
 */
var path = __importStar(require("path"));
var interfaces_1 = require("./interfaces");
var cloneDeep_1 = __importDefault(require("lodash/cloneDeep"));
var get_1 = __importDefault(require("lodash/get"));
var generators_1 = require("./generators");
var utils_1 = require("./utils");
// consider all models except associative tables and 'Archive' model special case
var removeModelExceptions = function (model) { return !!model.globalId && model.globalId !== 'Archive'; };
exports.parseModels = function (sails, sailsConfig, sailsModels) {
    if (sailsModels === void 0) { sailsModels = []; }
    return __awaiter(void 0, void 0, void 0, function () {
        var models, modelDir, swaggerComments, parseTagsComponents, parseSwaggerDocPaths;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    models = sailsModels.filter(removeModelExceptions);
                    modelDir = sailsConfig.paths.models;
                    return [4 /*yield*/, Promise.all(models.map(function (model) {
                            return utils_1.loadSwaggerDocComments(require.resolve(path.join(modelDir, model.globalId))).catch(function (err) {
                                sails.log.error("ERROR: sails-hook-swagger-generator: Error resolving/loading model " + model.globalId + ": " + (err.message || ''), err);
                                return undefined;
                            });
                        }))];
                case 1:
                    swaggerComments = _a.sent();
                    parseTagsComponents = function (model, index) {
                        // retrieve swagger documentation from jsDoc comments and merge it with any .swagger within our model
                        var swagger = swaggerComments[index];
                        model.swagger = cloneDeep_1.default(model.swagger || {});
                        if (swagger) {
                            model.swagger = utils_1.mergeSwaggerSpec(model.swagger, swagger);
                        }
                        return model;
                    };
                    parseSwaggerDocPaths = function (model, index) {
                        // parse and merge swagger.actions and swagger-doc path (and take them as precendence) 
                        var swagger = swaggerComments[index];
                        if (swagger) {
                            var paths = swagger.paths || {};
                            model.swagger.actions = utils_1.mergeSwaggerPaths(model.swagger.actions, paths);
                        }
                        return model;
                    };
                    return [2 /*return*/, models
                            .map(parseTagsComponents)
                            .map(parseSwaggerDocPaths)
                            .reduce(function (parsed, model) {
                            parsed[model.globalId.toLowerCase()] = model;
                            return parsed;
                        }, {})];
            }
        });
    });
};
exports.parseCustomRoutes = function (sailsConfig) {
    var routes = utils_1.removeViewRoutes(sailsConfig.routes);
    var customRoutes = [];
    var _loop_1 = function (routeAddress) {
        // Parse 1: Route Address
        // see https://sailsjs.com/documentation/concepts/routes/custom-routes#?route-address
        var _a = routeAddress.split(/\s+/), _b = _a[0], verb = _b === void 0 ? 'get' : _b, path_1 = _a[1];
        verb = verb.toLowerCase();
        if (!path_1) {
            path_1 = verb;
            verb = 'all';
        }
        // https://sailsjs.com/documentation/concepts/routes/custom-routes#?wildcards-and-dynamic-parameters
        var swaggerPathParams = generators_1.generateSwaggerPath(path_1);
        // XXX TODO wildcard
        // XXX TODO Handle arrays
        // https://sailsjs.com/documentation/concepts/routes/custom-routes#?route-target
        // https://sailsjs.com/documentation/concepts/routes/custom-routes#?policy-target-syntax
        // https://sailsjs.com/documentation/concepts/routes/custom-routes#?function-target-syntax
        // XXX TODO Handle these variations
        // https://sailsjs.com/documentation/concepts/routes/custom-routes#?regular-expressions-in-addresses
        // https://sailsjs.com/documentation/concepts/routes/custom-routes#?routing-to-blueprint-actions
        // https://sailsjs.com/documentation/concepts/routes/custom-routes#?redirect-target-syntax (starts with / or scheme)
        // https://sailsjs.com/documentation/concepts/routes/custom-routes#?response-target-syntax
        // https://sailsjs.com/documentation/concepts/routes/custom-routes#?policy-target-syntax
        // https://sailsjs.com/documentation/concepts/actions-and-controllers#?actions-2
        // Parse 2: Route target
        var routeTarget = utils_1.normalizeRouteControllerTarget(routes[routeAddress]);
        var parsedRoute = __assign(__assign({ verb: verb }, swaggerPathParams), routeTarget);
        if (verb !== 'all') {
            customRoutes.push(parsedRoute);
        }
        else {
            ['get', 'post', 'put', 'patch', 'delete'].forEach(function (v) {
                customRoutes.push(__assign(__assign({}, parsedRoute), { verb: v }));
            });
        }
    };
    for (var routeAddress in routes) {
        _loop_1(routeAddress);
    }
    return customRoutes;
};
var getAssociationPrimaryKeyAttribute = function (routeOptions, models) {
    var associations = routeOptions.associations || [];
    var association = associations.find(function (item) { return item.alias === routeOptions.alias; });
    if (!association) {
        return;
    }
    var identity = association.collection || association.model;
    var model = models[identity];
    if (!model) {
        return;
    }
    var associationInfo = get_1.default(model.attributes, "[" + model.primaryKey + "]", { description: '' });
    return __assign(__assign({}, associationInfo), { description: "**" + model.globalId + "** record's foreign key value (**" + routeOptions.alias + "** association" + (associationInfo.description ? '; ' + associationInfo.description : '') + ")" });
};
var groupAggregatedModelRoutes = function (routes, type) {
    return routes.filter(function (route) { return route.action === type; })
        .reduce(function (grouped, route) {
        var identity = route.model.identity;
        if (!grouped[identity]) {
            grouped[identity] = [];
        }
        grouped[identity].push(route);
        return grouped;
    }, {});
};
/*
  * Sails returns individual routes for each association:
  * - /api/v1/quote/:parentid/supplier/:childid
  * - /api/v1/quote/:parentid/items/:childid
  *
  * We now aggreggate these routes.
  */
var aggregateAssociationRoutes = function (blueprintRoutes, models) {
    var aggregatedRoutesByModel = {
        populateByModel: groupAggregatedModelRoutes(blueprintRoutes, 'populate'),
        addByModel: groupAggregatedModelRoutes(blueprintRoutes, 'add'),
        removeByModel: groupAggregatedModelRoutes(blueprintRoutes, 'remove'),
        replaceByModel: groupAggregatedModelRoutes(blueprintRoutes, 'replace'),
    };
    var processAggregationModelRoutes = function (route, byModel) {
        var byModelRoutes = aggregatedRoutesByModel[byModel][route.model.identity];
        if (!byModelRoutes) {
            return undefined;
        }
        var primaryKey = route.model.primaryKey;
        route.path = route.path.replace(new RegExp("/{parentid}/" + route.alias + "$", 'g'), "/{" + primaryKey + "}/{association}");
        route.path = route.path.replace(new RegExp("/{parentid}/" + route.alias + "/{childid}$", 'g'), "/{" + primaryKey + "}/{association}/{fk}");
        var associationPrimaryKeyAttribute = function (r) { return r.associations && r.alias ? getAssociationPrimaryKeyAttribute(r, models) : undefined; };
        route.aliases = byModelRoutes.map(function (r) { return r.alias; }).filter(function (alias) { return !!alias; });
        route.associationsPrimaryKeyAttribute = byModelRoutes.map(associationPrimaryKeyAttribute).filter(function (attr) { return !!attr; });
        return route;
    };
    return blueprintRoutes.map(function (route) {
        if (route.action === 'populate')
            return processAggregationModelRoutes(route, 'populateByModel');
        if (route.action === 'add')
            return processAggregationModelRoutes(route, 'addByModel');
        if (route.action === 'remove')
            return processAggregationModelRoutes(route, 'removeByModel');
        if (route.action === 'replace')
            return processAggregationModelRoutes(route, 'replaceByModel');
        return route;
    });
};
exports.parseBindRoutes = function (boundRoutes, models, sails) {
    var routes = utils_1.getBlueprintAllowedMiddlewareRoutes(boundRoutes);
    var parsedRoutes = routes.map(function (route) {
        var routeOptions = route.options;
        var identity = routeOptions.model;
        var _middlewareType = routeOptions._middlewareType;
        var _a = _middlewareType.split(':'), middlewareType = _a[0], _b = _a[1], actionName = _b === void 0 ? '' : _b;
        var blueprintAction = actionName.toLowerCase().trim();
        if (!identity && routeOptions.action) {
            // custom blueprint actions may not have model name explicitly specified --> extract from action
            identity = routeOptions.action.split('/')[0];
        }
        var model = models[identity];
        if (!model) {
            sails.log.warn("WARNING: sails-hook-swagger-generator: Ignoring unregconised shadow/implicit route " + route.path + " (type " + middlewareType + ") referencing unknown model " + identity);
            return;
        }
        var controller = utils_1.normalizeRouteControllerName(model.globalId);
        var tags = get_1.default(model.swagger, 'tags', []);
        var swagger = get_1.default(model.swagger.actions, blueprintAction + "." + route.verb);
        var swaggerPathParams = generators_1.generateSwaggerPath(route.path);
        if (model.primaryKey && model.primaryKey !== 'id') {
            swaggerPathParams.path = swaggerPathParams.path.replace('{id}', "{" + model.primaryKey + "}");
        }
        return __assign(__assign({}, swaggerPathParams), { verb: route.verb, model: model, action: blueprintAction, controller: controller,
            tags: tags,
            swagger: swagger, aliases: [], alias: routeOptions.alias, associations: routeOptions.associations, middlewareType: interfaces_1.MiddlewareType.BLUEPRINT, associationsPrimaryKeyAttribute: [] });
    }).filter(function (route) { return !!route; });
    return aggregateAssociationRoutes(parsedRoutes, models)
        .filter(function (route) { return !!route; });
};
var toSwaggerRoute = function (customRoute, models) {
    var route = __assign(__assign({}, customRoute), { tags: [], aliases: [], associations: [], associationsPrimaryKeyAttribute: [] });
    // use controller name as model identity name 
    if (customRoute.controller) {
        var _a = customRoute.controller.split('Controller')[0], identity = _a === void 0 ? '' : _a;
        var model = models[identity.toLowerCase()];
        route.model = model;
        route.tags = get_1.default(model, 'swagger.tags', []);
    }
    return route;
};
/**
 * Merge both custom and bound routes, we only need
 * .swagger,.action and .controller props from custom
 * merge the others with bound routes
 * attached to customRoutes takes precedence over boundRoutes
 *
 * @param customRoutes
 * @param boundRoutes
 */
exports.mergeCustomAndBindRoutes = function (customRoutes, boundRoutes, models) {
    // blueprints routes from bound routes
    var merged = boundRoutes.map(function (route) {
        var customRoute = customRoutes.find(function (croute) { return croute.path === route.path && croute.verb === route.verb; });
        if (customRoute) {
            route.swagger = customRoute.swagger;
            route.action = customRoute.action;
            route.controller = customRoute.controller;
        }
        return route;
    });
    // custom routes not in above blueprint routes
    customRoutes.forEach(function (customRoute) {
        if (!merged.find(function (mergedRoute) { return mergedRoute.path === customRoute.path && mergedRoute.verb === customRoute.verb; })) {
            merged.push(toSwaggerRoute(customRoute, models));
        }
    });
    return merged;
};
exports.parseControllers = function (sails, controllerNames) { return __awaiter(void 0, void 0, void 0, function () {
    var controllerDir, swaggerDocComments, parseController, parseTagsComponents, parseSwaggerDocPaths;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                controllerDir = sails.config.paths.controllers;
                return [4 /*yield*/, Promise.all(controllerNames.map(function (name) { return __awaiter(void 0, void 0, void 0, function () {
                        var filePath;
                        return __generator(this, function (_a) {
                            try {
                                filePath = require.resolve(path.join(controllerDir, name));
                            }
                            catch (err) {
                                sails.log.error("ERROR: sails-hook-swagger-generator: Error resolving/loading controller " + name + ": " + (err.message || ''), err);
                                return [2 /*return*/, undefined];
                            }
                            return [2 /*return*/, utils_1.loadSwaggerDocComments(filePath).catch(function (err) {
                                    sails.log.error("ERROR: sails-hook-swagger-generator: Error resolving/loading controller " + name + ": " + (err.message || ''), err);
                                    return undefined;
                                })];
                        });
                    }); }))];
            case 1:
                swaggerDocComments = _a.sent();
                parseController = function (name) {
                    try {
                        var controllerPath = path.join(controllerDir, name);
                        // eslint-disable-next-line @typescript-eslint/no-var-requires
                        var controllerOrAction = require(controllerPath);
                        if (controllerOrAction) {
                            return __assign({ name: name }, controllerOrAction);
                        }
                    }
                    catch (err) {
                        sails.log.error("ERROR: sails-hook-swagger-generator: Error resolving/loading controller " + name + ": " + (err.message || ''), err);
                    }
                    return { name: name, swagger: {} };
                };
                parseTagsComponents = function (controller, index) {
                    // retrieve swagger documentation from jsDoc comments and merge it with any .swagger within our controller
                    var swagger = swaggerDocComments[index];
                    controller.swagger = cloneDeep_1.default(controller.swagger || {});
                    if (swagger) {
                        controller.swagger = utils_1.mergeSwaggerSpec(controller.swagger, swagger);
                    }
                    return controller;
                };
                parseSwaggerDocPaths = function (controller, index) {
                    // parse and merge swagger.actions and swagger-doc path (and take them as precendence) 
                    var swagger = swaggerDocComments[index];
                    if (swagger) {
                        var paths = swagger.paths || {};
                        controller.swagger.actions = utils_1.mergeSwaggerPaths(controller.swagger.actions, paths);
                    }
                    return controller;
                };
                return [2 /*return*/, controllerNames
                        .map(parseController)
                        .map(parseTagsComponents)
                        .map(parseSwaggerDocPaths)
                        .reduce(function (parsed, controller) {
                        parsed[controller.name] = controller;
                        return parsed;
                    }, {})];
        }
    });
}); };
exports.attachControllerOrActionSwagger = function (routesInfo, controllers, action2s) {
    return routesInfo.map(function (route) {
        if (route.swagger) {
            return route;
        }
        route.swagger = utils_1.getSwaggerAction(controllers[route.controller], route.action);
        if (!route.swagger) {
            route.swagger = utils_1.getSwaggerAction(action2s[route.action], utils_1.getActionNameFromPath(route.action));
        }
        return route;
    });
};
