"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = __importStar(require("fs"));
var cloneDeep_1 = __importDefault(require("lodash/cloneDeep"));
var uniqBy_1 = __importDefault(require("lodash/uniqBy"));
var type_formatter_1 = require("./type-formatter");
var parsers_1 = require("./parsers");
var utils_1 = require("./utils");
var generators_1 = require("./generators");
exports.default = (function (sails, sailsRoutes, context) { return __awaiter(void 0, void 0, void 0, function () {
    var hookConfig, blueprintActionTemplates, specifications, defaults, models, customRoutes, allRoutes, routes, withoutSwaggerRoutes, uniqueControllers, controllers, action2Paths, action2s, referencedTags, destPath;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                hookConfig = sails.config[context.configKey];
                if (hookConfig.disabled) {
                    return [2 /*return*/];
                }
                blueprintActionTemplates = cloneDeep_1.default(type_formatter_1.blueprintActionTemplates);
                if (hookConfig.updateBlueprintActionTemplates) {
                    blueprintActionTemplates = hookConfig.updateBlueprintActionTemplates(blueprintActionTemplates);
                }
                specifications = __assign({ tags: [], components: {} }, cloneDeep_1.default(hookConfig.swagger));
                defaults = hookConfig.defaults || type_formatter_1.defaults;
                return [4 /*yield*/, parsers_1.parseModels(sails, sails.config, Object.keys(sails.models).map(function (key) { return sails.models[key]; }))];
            case 1:
                models = _a.sent();
                customRoutes = parsers_1.parseCustomRoutes(sails.config);
                allRoutes = parsers_1.parseBindRoutes(sailsRoutes, models, sails);
                // remove globally excluded routes
                allRoutes = allRoutes.filter(function (route) { return route.path !== '/__getcookie'; });
                routes = parsers_1.mergeCustomAndBindRoutes(customRoutes, allRoutes, models);
                if (hookConfig.includeRoute) {
                    routes = routes.filter(function (route) { return hookConfig.includeRoute(route); });
                }
                if (!specifications.tags)
                    specifications.tags = [];
                if (!specifications.components)
                    specifications.components = {};
                withoutSwaggerRoutes = routes.filter(function (route) { return !route.swagger; });
                uniqueControllers = uniqBy_1.default(withoutSwaggerRoutes, 'controller')
                    .map(function (route) { return route.controller; })
                    .filter(function (controller) { return !!controller; });
                return [4 /*yield*/, parsers_1.parseControllers(sails, uniqueControllers)];
            case 2:
                controllers = _a.sent();
                action2Paths = utils_1.getAction2Paths(withoutSwaggerRoutes);
                return [4 /*yield*/, parsers_1.parseControllers(sails, action2Paths)];
            case 3:
                action2s = _a.sent();
                routes = parsers_1.attachControllerOrActionSwagger(routes, controllers, action2s);
                specifications.components.schemas = generators_1.generateSchemas(models);
                // merge model, controller and action2 .components and .tags
                specifications.components = utils_1.mergeComponents(specifications.components, models, controllers, action2s);
                specifications.tags = utils_1.mergeTags(specifications.tags, models, controllers, action2s);
                specifications.paths = generators_1.generatePaths(routes, blueprintActionTemplates, defaults, action2s, specifications);
                specifications.components.parameters = __assign(__assign({}, type_formatter_1.blueprintParameterTemplates), specifications.components.parameters);
                referencedTags = utils_1.getUniqueTagsFromPath(specifications.paths);
                specifications.tags = specifications.tags.filter(function (tag) { return referencedTags.has(tag.name); });
                if (hookConfig.postProcess)
                    hookConfig.postProcess(specifications);
                destPath = hookConfig.swaggerJsonPath;
                try {
                    fs.writeFileSync(destPath, JSON.stringify(specifications, null, 2));
                }
                catch (e) {
                    sails.log.error("ERROR: sails-hook-swagger-generator: Error writing " + destPath + ": " + e.message, e);
                }
                sails.log.info('Swagger generated successfully');
                return [2 /*return*/, specifications];
        }
    });
}); });
