"use strict";
/* eslint-disable @typescript-eslint/no-explicit-any */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var swagger_doc_test_1 = __importDefault(require("./swagger-doc.test"));
/**
 * Created by theophy on 02/08/2017.
 */
var Sails = require('sails').Sails;
// eslint-disable-next-line @typescript-eslint/no-var-requires
var swaggergenerator = require('../');
describe('Basic tests ::', function () {
    // Var to hold a running sails app instance
    var sails;
    // Before running any tests, attempt to lift Sails
    before(function (done) {
        // Hook will timeout in 10 seconds
        this.timeout(11000);
        // Attempt to lift sails
        Sails().lift({
            blueprints: {
                shortcuts: false,
            },
            hooks: {
                // Load the hook
                swaggergenerator: swaggergenerator,
                // Skip grunt (unless your hook uses it)
                grunt: false
            },
            log: { level: "silent" }
        }, function (err, _sails) {
            if (err)
                return done(err);
            sails = _sails;
            return done();
        });
    });
    // After tests are complete, lower Sails
    after(function (done) {
        // Lower Sails (if it successfully lifted)
        if (sails) {
            return sails.lower(done);
        }
        // Otherwise just return
        return done();
    });
    // Test that Sails can lift with the hook in place
    it('sails does not crash on loading our hook', function () {
        return true;
    });
    swagger_doc_test_1.default();
});
