"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable @typescript-eslint/no-empty-function */
var chai_1 = require("chai");
var parsers_1 = require("../lib/parsers");
var parsedRoutes_json_1 = __importDefault(require("./fixtures/parsedRoutes.json"));
var utils_1 = require("../lib/utils");
// eslint-disable-next-line @typescript-eslint/no-var-requires
var userModel = require('../../api/models/User');
// eslint-disable-next-line @typescript-eslint/no-var-requires
var routes = require('../../config/routes');
var sailsConfig = {
    paths: {
        models: '../../api/models',
        controllers: '../../api/controllers'
    },
    routes: routes.routes,
    appPath: ''
};
var sails = {
    log: {
        warn: function () { },
        error: function () { }
    },
    config: sailsConfig
};
describe('Parsers', function () {
    var models = [
        __assign({ globalId: 'User' }, userModel),
        {
            attributes: {}
        },
        {
            globalId: 'Archive'
        }
    ];
    var boundRoutes = [
        {
            "path": "/user",
            "verb": "get",
            "options": {
                "model": "user",
                "associations": [],
                "detectedVerb": {
                    "verb": "",
                    "original": "/user",
                    "path": "/user"
                },
                "action": "user/find",
                "_middlewareType": "BLUEPRINT: find",
                "skipRegex": []
            }
        },
        {
            "path": "/user/:id",
            "verb": "get",
            "options": {
                "model": "user",
                "associations": [],
                "autoWatch": true,
                "detectedVerb": {
                    "verb": "",
                    "original": "/user/:id",
                    "path": "/user/:id"
                },
                "action": "user/findone",
                "_middlewareType": "BLUEPRINT: findone",
                "skipRegex": [
                    {}
                ],
                "skipAssets": true
            }
        },
        {
            "path": "/user/:id",
            "verb": "put",
            "options": {
                "associations": [],
                "autoWatch": true,
                "detectedVerb": {
                    "verb": "",
                    "original": "/user/:id",
                    "path": "/user/:id"
                },
                "action": "user/update",
                "_middlewareType": "BLUEPRINT: update",
                "skipRegex": [
                    {}
                ],
                "skipAssets": true
            }
        },
        {
            "path": "/actions2",
            "verb": "get",
            "options": {
                "detectedVerb": {
                    "verb": "",
                    "original": "/actions2",
                    "path": "/actions2"
                },
                "action": "subdir/actions2",
                "_middlewareType": "ACTION: subdir/actions2",
                "skipRegex": []
            }
        }
    ];
    describe('parseModels', function () {
        it("should only consider all models except associative tables and 'Archive' model special case ", function () { return __awaiter(void 0, void 0, void 0, function () {
            var parsedModels;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, parsers_1.parseModels(sails, sails.config, models)];
                    case 1:
                        parsedModels = _a.sent();
                        chai_1.expect(Object.keys(parsedModels).length).to.equal(1);
                        chai_1.expect(parsedModels['user'], 'key parsed models with their globalId').to.be.ok;
                        return [2 /*return*/];
                }
            });
        }); });
        it('should load and merge swagger specification in /models/{globalId} with the model.swagger attribute', function () { return __awaiter(void 0, void 0, void 0, function () {
            var parsedModels, expectedTags;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, parsers_1.parseModels(sails, sails.config, models)];
                    case 1:
                        parsedModels = _a.sent();
                        expectedTags = [
                            {
                                "name": "User (ORM)",
                                "description": "A longer, multi-paragraph description\nexplaining how this all works.\n\nIt is linked to more information.\n",
                                "externalDocs": {
                                    "url": "https://somewhere.com/yep",
                                    "description": "Refer to these docs"
                                }
                            },
                            {
                                "name": "User (ORM duplicate)",
                                "externalDocs": {
                                    "url": "https://somewhere.com/alternate",
                                    "description": "Refer to these alternate docs"
                                }
                            }
                        ];
                        chai_1.expect(parsedModels.user.swagger.tags, 'should merge tags from swagger doc with Model.swagger.tags').to.deep.equal(expectedTags);
                        chai_1.expect(parsedModels.user.swagger.components, 'should merge components from swagger doc with Model.swagger.components').to.deep.equal({ parameters: [] });
                        chai_1.expect(parsedModels.user.swagger.actions, 'should convert and merge swagger doc path param to actions').to.contains.keys('findone', 'find');
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('parseCustomRoutes', function () {
        it('should parse routes from config/routes.js or sails.routes', function (done) {
            var actual = parsers_1.parseCustomRoutes(sails.config);
            chai_1.expect(JSON.stringify(actual)).to.equal(JSON.stringify(parsedRoutes_json_1.default));
            done();
        });
    });
    describe('parseBindRoutes: sails router:bind event', function () {
        it('Should only parse blueprint routes', function () { return __awaiter(void 0, void 0, void 0, function () {
            var parsedModels, actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, parsers_1.parseModels(sails, sailsConfig, models)];
                    case 1:
                        parsedModels = _a.sent();
                        actual = parsers_1.parseBindRoutes(boundRoutes, parsedModels, sails);
                        chai_1.expect(actual.every(function (route) { return utils_1.bluerprintActions.includes(route.action); })).to.be.true;
                        return [2 /*return*/];
                }
            });
        }); });
        it('Should contain route model', function () { return __awaiter(void 0, void 0, void 0, function () {
            var parsedModels, actual, updateUserRoute;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, parsers_1.parseModels(sails, sailsConfig, models)];
                    case 1:
                        parsedModels = _a.sent();
                        actual = parsers_1.parseBindRoutes(boundRoutes, parsedModels, sails);
                        chai_1.expect(actual.every(function (route) { return !!route.model; }), 'Should return model for all routes');
                        updateUserRoute = actual.find(function (route) { return route.action === 'update'; });
                        chai_1.expect(!!(updateUserRoute === null || updateUserRoute === void 0 ? void 0 : updateUserRoute.model), 'should parse blueprint routes and auto add model to routes without model').to.be.true;
                        chai_1.expect(updateUserRoute === null || updateUserRoute === void 0 ? void 0 : updateUserRoute.path, 'should convert sails path param to swagger param with :id to {id}').to.equal('/user/{id}');
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('mergeCustomAndBindRoutes', function () {
        it('should merge both custom and bound routes', function () { return __awaiter(void 0, void 0, void 0, function () {
            var parsedModels, parsedBoundRoutes, parsedCustomRoutes, mergedRoutes;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, parsers_1.parseModels(sails, sailsConfig, models)];
                    case 1:
                        parsedModels = _a.sent();
                        parsedBoundRoutes = parsers_1.parseBindRoutes(boundRoutes, parsedModels, sails);
                        parsedCustomRoutes = parsers_1.parseCustomRoutes(sails.config);
                        mergedRoutes = parsers_1.mergeCustomAndBindRoutes(parsedCustomRoutes, parsedBoundRoutes, parsedModels);
                        chai_1.expect(mergedRoutes
                            .filter(function (route) { return route.controller && route.controller.includes('Controller'); })
                            .every(function (route) { return !!route.model; }), 'should attach model to custom routes with controller routes if existing').to.be.true;
                        chai_1.expect(mergedRoutes.length, 'merge both custom and bound routes').to.equal(18);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('parseControllers', function () {
        it('should load and merge swagger specification in /controllers/{name} with the controller.swagger attribute', function () { return __awaiter(void 0, void 0, void 0, function () {
            var parsedControllers, expectedTags;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, parsers_1.parseControllers(sails, ['UserController'])];
                    case 1:
                        parsedControllers = _a.sent();
                        expectedTags = [
                            {
                                name: 'Auth Mgt',
                                description: 'User management and login'
                            },
                            {
                                name: 'User List',
                                description: 'Group just for user list operation',
                            }
                        ];
                        chai_1.expect(parsedControllers.UserController.swagger.tags, 'should merge tags from swagger doc with Controller.swagger.tags').to.deep.equal(expectedTags);
                        chai_1.expect(parsedControllers.UserController.swagger.components, 'should merge components from swagger doc with Controller.swagger.components').to.deep.equal({ parameters: [] });
                        chai_1.expect(parsedControllers.UserController.swagger.actions, 'should convert and merge swagger doc path param to actions').to.contains.keys('list', 'logout');
                        return [2 /*return*/];
                }
            });
        }); });
        it('Action2: should load and merge swagger specification in /controllers/{action2-name} with the action2.swagger attribute', function () { return __awaiter(void 0, void 0, void 0, function () {
            var parsedControllers, expectedTags;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, parsers_1.parseControllers(sails, ['subdir/actions2'])];
                    case 1:
                        parsedControllers = _a.sent();
                        expectedTags = [
                            {
                                name: 'Action2 Mgt',
                                description: 'Action2 testing'
                            },
                            {
                                name: 'Actions2 Group',
                                description: 'A test actions2 group',
                            }
                        ];
                        chai_1.expect(parsedControllers['subdir/actions2'].swagger.tags, 'should merge tags from swagger doc with Action2.swagger.tags').to.deep.equal(expectedTags);
                        chai_1.expect(parsedControllers['subdir/actions2'].swagger.components, 'should merge components from swagger doc with Action2.swagger.components').to.deep.equal({ parameters: [] });
                        chai_1.expect(parsedControllers['subdir/actions2'].swagger.actions, 'should convert and merge swagger doc path param to actions').to.contains.keys('actions2');
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
